//
// Dekoder ukrytego kodu dla pliku patch.bin
//
// Bartosz Wjcik - support@pelock.com
//

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int main()
{
	HMODULE hModule;
	HRSRC hRes;
	HGLOBAL hRsrc;
	BYTE *lpCode, *lpTemp;
	BYTE *hLocked;
	DWORD dwCode,i = 0,j = 0, k;
	FILE *hOutput;
	char lpszFilename[] = "ukryty_kod.bin";

	// zaaduj plik patch.bin jako plik danych
	hModule = LoadLibraryEx("patch.bin", NULL, LOAD_LIBRARY_AS_DATAFILE);

	// sprawd czy plik zosta wgrany do pamici
	if (hModule != 0)
	{
		// szukaj w zasobach pliku bitmapy o identyfikatorze 105
		hRes = FindResource(hModule,MAKEINTRESOURCE(105),RT_BITMAP);

		// sprawd czy znaleziono bitmap
		if (hRes != 0)
		{
			// zaaduj bitmap z zasobw
			hRsrc = LoadResource(hModule,hRes);

			// zablokuj wskanik do zaadowanej bitmapy, w wyniku
			// wywoania tej funkcji, w zmiennej hLocked znajdzie
			// si adres pierwszego bajtu danych bitmapy
			hLocked = (BYTE *)LockResource(hRsrc);

			// ilo pikseli zapisanych w bitmapie * 3
			dwCode = (*(DWORD *)(hLocked + 0x4)) * (*(DWORD *)(hLocked + 0x8)) * 3;

			// alokuj pami do wrzucenia tam kodu (wyzerowana)
			lpCode = calloc(dwCode,1);

			// ustaw wskanik lpTemp na skadowe RGB bitmapy (po nagwku)
			lpTemp = (BYTE *)(hLocked + 0x28);

			// wycignij ze skadowych RGB kolejne bajty ukrytego kodu
			while (i < dwCode)
			{
				// skadanie bajtu ukrytego kodu z 8 kolejnych
				// bitw skadowych kolorw
				for (k = 0; k < 8; k++)
				{
					lpCode[j] |= ( lpTemp[i++] & 1 ) << k;
				}
				
				// zwiksz indeks bufora danych lpCode
				j++;
			}

			// utwrz nowy plik binarny
			hOutput = fopen(lpszFilename,"wb+");

			// zapisz do niego zawarto ukrytego kodu
			fwrite(lpCode, j, 1, hOutput);

			// zamknij plik
			fclose(hOutput);

		}
	}

	// zakocz program
	return 0;
}
